/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/* Header file */
#include "js-scriptruntime.h"
#include "js-interpreter.h"
#include "js-exceptionhandler.h"
#include "js-interpretedfunction.h"

/* Internal data */
const jsString_t JSInterpretedFunction::className = "InterpretedFunction";

/* Procedures */
void JSInterpretedFunction::init(JSContext * cx)
{
    // probably too much copying going on from theData
    // to the InterpretedFunction object
    // should pass them as parameters - unless we need them
    // in the data block anyway?
    int size = itsData->itsVariableTable->size();

    namesLength = 0;    // gc safe
    names = (jsString_t *) JS_NewGCObj(cx, sizeof(*names) * (size + 1));
    memset(names, 0, sizeof(*names) * (size + 1));
    namesLength = size + 1;
    names[0] = itsData->itsName;
    for (int i = 0; i < size; i++) {
        names[i + 1] = itsData->itsVariableTable->getName(i);
    }
    argCount = (short)itsData->itsVariableTable->getParameterCount();
    source = itsData->itsSource;
    sourceLength = itsData->itsSourceLength;
    nestedFunctions = (JSNativeFunction **) itsData->itsNestedFunctions;
    if (cx != NULL) {
        version = (short)cx->getLanguageVersion();
    }
}
jsBool_t JSInterpretedFunction::isInstanceOf(const jsString_t className)
{
    if (className == JSInterpretedFunction::className)
        return TRUE;
    return JSNativeFunction::isInstanceOf(className);
}

jsVal_t JSInterpretedFunction::call(JSContext * cx, JSScriptable * scope, JSScriptable * thisObj, int numArgs, jsVal_t * args)
{
    if (itsClosure != NULL) {
        scope = itsClosure;
    }
    else if (!itsData->itsUseDynamicScope) {
        scope = getParentScope(cx);
    }
    if (itsData->itsNeedsActivation) {
        scope = JSScriptRuntime::initVarObj(cx, scope, this, thisObj, numArgs, args);
    }

    if (itsData->itsNeedsActivation) {  // to avoid frequent enterTry 
        JSException *ex;

        if ((ex = enterTry(cx)) == NULL) {
            jsVal_t result = JSInterpreter::interpret(cx, scope, thisObj, numArgs,
                    args, itsData);
            cx->exceptionHandler->exitTry();
            JSScriptRuntime::popActivation(cx);
            return result;
        }
        else {
            JSScriptRuntime::popActivation(cx);
            cx->exceptionHandler->throwEx(ex);
        }
        /* NOT REACHED */
        return JS_VAL_NULL;
    }
    return JSInterpreter::interpret(cx, scope, thisObj, numArgs, args, itsData);
}

void JSInterpretedFunction::mark(JSContext * cx)
{
    JSGCHeap *gcHeap = &cx->runtime->gcHeap;

    if (gcHeap->isMarkObj(this))
        return;

    JSNativeFunction::mark(cx);
    itsData->mark(cx);
    if (itsClosure != NULL) {
        itsClosure->mark(cx);
    }
}

JSInterpretedFunction::JSInterpretedFunction(JSInterpreterData * theData, JSContext * cx)
{
    itsData = theData;
    itsClosure = NULL;
    init(cx);
}

JSInterpretedFunction::JSInterpretedFunction(JSInterpretedFunction * theOther, JSScriptable * theScope, JSContext * cx)
{
    itsData = theOther->itsData;
    itsClosure = theScope;
    init(cx);
}
